class ClientStuff expands ReplicationInfo;

// By: Age

// Stuff that spawns.
	
var ChristmasMut Mut;
var string MapNamed;

var() float Area;
var() float AreaHeight;

var() int ParticleCountX;
var() float ParticleSpeedMin;
var() float ParticleSpeedMax;
var() float ParticleSizeMin;
var() float ParticleSizeMax;

/*var() config bool bIsVariable;

var() config struct TimeRate
{
	var() config int Min;
	var() config int Max;
} CTimeRate;

var() config struct ParticleStorm
{
	var() config int Min;
	var() config int Max;
} CParticleCount;

var() config struct ParticleSpeed
{
	var() config int Min;
	var() config int Max;
} CParticleSpeed;

var() config struct ParticleAngle
{
	var() config int Min;
	var() config int Max;
} CParticleAngle;

var() config struct ParticleSize
{
	var() config int Min;
	var() config int Max;
} CParticleSize;*/

struct ClientLocationType
{
	var() vector TheLocation;
	var() float TheDrawScale;
	var() texture TheSkin;
	var() byte TheLightBrightness;
	var() byte TheLightHue;
	var() byte TheLightSaturation;
	var() byte TheLightRadius;
	var() float TheCoronaSize;
	var() float TheDisplayDistance;
	var() float TheFadeOutDistance;
	var() float MaxSize;
}; var() array<ClientLocationType> ClientLocations;

struct CandleLocationType
{
	var() vector TheLocation;
	var() rotator TheRotation;
	var() class<actor> TheClass;
}; var() array<CandleLocationType> CandleLocations;

var float Count;
var bool Do1;
var int Limit1;
var int Num1;

var bool Do2;
var int Limit2;
var int Num2;

replication
{
	reliable if(role==role_authority)
		Num1,Num2,SendCandleLenght,SetCandleValue,SendLocationsLenght,SetLocationArrayValue,ParticleCountX,ParticleSpeedMin,ParticleSpeedMax,ParticleSizeMin,ParticleSizeMax,Area,AreaHeight,CallSnow,Mut;
}

simulated function SetLocationArrayValue(int Index, vector Value2, float Value3, float Value4, texture Value5, byte Value6, byte Value7, byte Value8, byte Value9, float Value10, float Value11, float Value12, float Value13, float Value14) // Send array values from server to client.
{
	local ClientCorona CC;

	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return;

	ClientLocations[Index].TheLocation = Value2;
	ClientLocations[Index].TheDrawScale = Value3;
	ClientLocations[Index].TheSkin = Value5;
	ClientLocations[Index].TheLightBrightness = Value6;
	ClientLocations[Index].TheLightHue = Value7;
	ClientLocations[Index].TheLightSaturation = Value8;
	ClientLocations[Index].TheLightRadius = Value9;
	ClientLocations[Index].TheCoronaSize = Value11;
	ClientLocations[Index].TheDisplayDistance = Value12;
	ClientLocations[Index].TheFadeOutDistance = Value13;
	ClientLocations[Index].MaxSize = Value14;
	
	CC = Spawn(class'ClientCorona',,,ClientLocations[Index].TheLocation); // Spawn a fake corona.
	if(CC!=None)
	{
		CC.DrawScale = ClientLocations[Index].TheDrawScale;
		CC.Skin = ClientLocations[Index].TheSkin;
		CC.LightBrightness = ClientLocations[Index].TheLightBrightness;
		CC.LightHue = ClientLocations[Index].TheLightHue;
		CC.LightSaturation = ClientLocations[Index].TheLightSaturation;
		CC.LightRadius = ClientLocations[Index].TheLightRadius;
		CC.CoronaSize = ClientLocations[Index].TheCoronaSize;
		CC.DisplayDistance = ClientLocations[Index].TheDisplayDistance;
		CC.FadeOutDistance = ClientLocations[Index].TheFadeOutDistance;
		CC.MaxSize = ClientLocations[Index].MaxSize;
	}
}

simulated function SetCandleValue(vector Value1, rotator Value2, class<actor> Value3) // Spawn "candles" clientside.
{
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return;
	Spawn(Value3,,,Value1,Value2);
}

simulated function SendLocationsLenght(int Count) // Send array lenght from server to client.
{
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return;
	InsertArrayIdx(ArrayProperty'ClientLocations',0,Count);
}

simulated function SendCandleLenght(int Count) // Send array lenght from server to client.
{
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return;
	InsertArrayIdx(ArrayProperty'CandleLocations',0,Count);
}

simulated function PreBeginPlay()
{	
	if( MapNamed=="" )
		MapNamed=Caps(string(Outer.Name));
}

function PostBeginPlay()
{
	SetTimer(3,False);
}

function Timer()
{
	if( PlayerPawn(Owner)==None || PlayerPawn(Owner).Player==None )
	{
		Destroy();
		Return;
	}
	Do1=True;
	SendLocationsLenght(Mut.GetArraySize(arrayproperty'Locations'));
	SendCandleLenght(Mut.GetArraySize(arrayproperty'Candles'));
	Limit1=Mut.GetArraySize(arrayproperty'Locations');
	Limit2=Mut.GetArraySize(arrayproperty'Candles');
	
	CallSnow(); // Call snow.
}

simulated function CallSnow() // Call snowy weather. Client only?
{
	local TheWeather TW;
	
	TW=Spawn(class'TheWeather',PlayerPawn(Owner),,PlayerPawn(Owner).location,rotator(vect(0,0,-1)));
	if(TW!=None)
	{
		TW.Mut = Mut;
		TW.Speed.Min=ParticleSpeedMin;
		TW.Speed.Max=ParticleSpeedMax;
		TW.Size.Min=ParticleSizeMin;
		TW.Size.Max=ParticleSizeMax;
		TW.PartTextures[0]=Texture'UnrealShare.Snow2';
		TW.PartTextures[1]=Texture'UnrealShare.Snow2';
		TW.PartTextures[2]=Texture'UnrealShare.Snow3';
		TW.WeatherType=EWF_Snow;
		TW.ParticleCount = ParticleCountX;
		TW.Position.X.Min = -Area;
		TW.Position.X.Max = Area;
		TW.Position.Y.Min = -Area;
		TW.Position.Y.Max = Area;
		TW.Position.Z.Max = AreaHeight;
		TW.Area = Area;
		TW.AreaHeight = AreaHeight;
	}
}
function Tick(float deltatime)
{
	if( PlayerPawn(Owner)==None || PlayerPawn(Owner).Player==None )
	{
		//Destroy();
		Return;
	}
	count+=deltatime;
	if(count>0.1)
	{
		if(Do1)
		{
			SetLocationArrayValue(num1,Mut.Locations[num1].TheLocation,Mut.Locations[num1].TheDrawScale,0,Mut.Locations[num1].TheSkin,Mut.Locations[num1].TheLightBrightness,Mut.Locations[num1].TheLightHue,Mut.Locations[num1].TheLightSaturation,Mut.Locations[num1].TheLightRadius,0,Mut.Locations[num1].TheCoronaSize,Mut.Locations[num1].TheDisplayDistance,Mut.Locations[num1].TheFadeOutDistance,Mut.Locations[num1].MaxSize); // Send info.
			Num1+=1;
			if(Num1>=Limit1 || Limit1<=0)
			{
				Do1 = False;
				Do2 = True;
			}
		}
		
		else if(Do2)
		{
			SetCandleValue(Mut.Candles[num2].TheLocation,Mut.Candles[num2].TheRotation,Mut.Candles[num2].TheClass); // Send info.
			Num2+=1;
			if(Num2>=Limit2 || Limit2<=0)
			{
				Do2 = False;
				LifeSpan = 3; // Die after 3 seconds.
			}
		}
		count=0;
	}
}

defaultproperties
{
				RemoteRole=ROLE_SimulatedProxy
				DrawScale=0.000000
				bAlwaysRelevant=False
}
